<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Http\Requests\FieldRequest;
use Exception;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Routing\Redirector;
use Illuminate\View\View;

use App\Field;
use App\Language;
use App\Module;
use Users_model;

class FieldController extends Controller
{
    /** Redirect to this path after each operation success*/
    private $redirectSuccessPath= '/admin/fields';
    /** View folder */
    private $viewDirectory= 'admin.fields.';

    /**
     * Display a listing of the resource.
     * @param Request $request
     * @return View
     */
    public function index(Request $request) :View
    {
        $title= __('fields.head');
        $request= $request->toArray();
        return view($this->viewDirectory.'index',compact('title'));
    }

    /**
     * return data of the fields.
     *
     * @param Request $request
     * @return View
     */
    public function grid(Request $request) :View
    {
        $query =Field::orderBy('name', 'ASC');

        if ($request->date_from) {
            $query->whereDate('created_at', '>=', $request->date_from);
        }

        if ($request->date_to) {
            $query->whereDate('created_at', '<=', $request->date_to);
        }

        if ($request->name) {
            $query->where('name', 'LIKE', '%'.$request->name.'%');
        }

       if ($request->lang) {
            $query->whereIn('language_id', currentLanguageid($request->lang) );
        }

      

        if ( !is_null($request->status) && $request->status == 0) {
            $query->onlyTrashed();
        }

        $fields= $query->paginate(100);

        return view($this->viewDirectory.'grid',compact('fields'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return View
     */
    public function create() :View
    {
        $action= route('fields.store');
        $head = metaFields('fields', 'add_new', getCurrentLocale()) ?? __('fields.new');
        $language = Language::where('status',1)->get();

        return view( $this->viewDirectory.'form', compact('action', 'head','language') );
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param FieldRequest $request
     * @return RedirectResponse|Redirector
     */
    public function store(FieldRequest $request) :RedirectResponse
    {

        foreach ($request->field as $key => $row) {
           $field= Field::create($row);
        }
        

        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  Field  $field
     * @return View
     */
    public function edit(Field $field): View
    {
        $action= route('fields.update', $field->id);
        $head = metaFields('fields', 'edit', getCurrentLocale()) ?? __('fields.edit');
        $language = Language::where('status',1)->get();

        return view( $this->viewDirectory.'form', compact( 'field','action', 'head' ,'language' ) );
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  FieldRequest  $request
     * @param  Field  $field
     * @return RedirectResponse|Redirector
     */
    public function update(FieldRequest $request, Field $field) :RedirectResponse
    {
        
        $field->update($request->all());
        

        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     * @throws Exception
     */
    public function destroy(Request $request, int $id) :JsonResponse
    {
        $field = Field::withTrashed()->find($id);
        if ($field) {
            if ($field->deleted_at) {
                $field->forceDelete();
            } else {
                $field->delete();
            }
            return response()->json(['message'=> __('dashboard.deletedDone')]);
        } else{
            return response()->json(['message'=> __('dashboard.noResult')], 400);
        }
    }

    /**
     * Remove several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function destroyAll(Request $request) :JsonResponse
    {
        $ids= $request->ids;
        if ($request->force) {
            Field::onlyTrashed()->whereIn('id', $ids)->forceDelete();
        } else {
            Field::whereIn('id', $ids)->delete();
        }

        return response()->json(['message'=> __('dashboard.deletedDone')]);
    }

    /**
     * Restore the specified category from storage
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     */
    public function restore(Request $request, int $id) :JsonResponse
    {
        $field = Field::withTrashed()->find($id);

        if ($field){
            $field->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
        return response()->json(['message'=> __('dashboard.noResult')], 400);
    }

    /**
     * Restore several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function restoreAll(Request $request) :JsonResponse
    {
        $field = Field::whereIn('id', $request->ids)->onlyTrashed();
        if ($field){
            $field->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
    }
}

